%define	pwdb_version		0.62
%define	pam_redhat_release	1
%define	_sbindir		%{_root_sbindir}

Summary:	A security tool which provides authentication for applications.
Name:		pam
Group:		System Environment/Base
License:	GPL or BSD
Version:	0.79
Release:	3
Source0:	ftp://ftp.kernel.org/pub/linux/libs/pam/pre/library/Linux-PAM-%{version}.tar.bz2
Source1:	pam-redhat-%{version}-%{pam_redhat_release}.tar.bz2
Source2:	pwdb-%{pwdb_version}.tar.gz

# Patches taken from Fedora
Patch100:	pam-0.75-prompt.patch
Patch101:	pam-0.77-lastlog-utmp.patch
Patch102:	pam-0.78-unix-hpux-aging.patch
Patch103:	pam-0.75-sgml2latex.patch
Patch104:	pam-0.77-dbpam.patch
Patch105:	pam-0.78-selinux.patch
Patch106:	pam-pwdbselinux.patch
Patch107:	pam-0.77-audit.patch
Patch108:	pam-0.79-tally-null-data.patch
Patch109:	pam-0.79-unix-nis.patch
Patch110:	pam-0.79-unix-lsb.patch
Patch111:	pam-0.79-misc-flush-first.patch
Patch112:	pam-0.79-cleanup.patch
Patch113:	pam-0.79-cleanup-redhat.patch
Patch114:	pam-0.79-xauth-unsetenv.patch
Patch115:	pam-0.79-console-perms-d.patch

# Our own patches
Patch300:	pam-0.79-engardeize-gd-2.diff
### Patch91:	pam-0.75-fix-broken-pam_limits-gd-2.diff	### DO WE STILL NEED THIS?

BuildRoot:	%{_tmppath}/%{name}-%{version}-root
Requires:	cracklib, cracklib-dicts, initscripts
Prereq:		grep, mktemp, sed, coreutils, /sbin/ldconfig
BuildPrereq:	autoconf, bison, sed, fileutils, cracklib
BuildPrereq:	cracklib-dicts, perl, db4-devel

%description
PAM (Pluggable Authentication Modules) is a system security tool that
allows system administrators to set authentication policy without
having to recompile programs that handle authentication.

%files
  %defattr(0444,root,root,0555)
  %doc Copyright doc/html doc/ps doc/txts doc/specs/rfc86.0.txt
  %doc %{_mandir}/man5/*
  %doc %{_mandir}/man8/*

# %dir %{_sysconfdir}/pam.d
# %dir /%{_lib}/security
# /%{_lib}/security/pam_filter

  %attr(0644,root,root)		%config %{_sysconfdir}/pwdb.conf
  %attr(0600,root,root)		%config(noreplace) %{_sysconfdir}/pam.d/other
  %attr(0600,root,root)		%config(noreplace) %{_sysconfdir}/pam.d/system-auth

  %attr(0500,root,root)		%{_root_sbindir}/*
  %attr(0755,root,root)		%dir %{_localstatedir}/run/console

  %attr(0555,root,root)		/%{_lib}/libpam.so.*
  %attr(0555,root,root)		/%{_lib}/libpamc.so.*
  %attr(0555,root,root)		/%{_lib}/libpam_misc.so.*

%ifarch x86_64
  %attr(0555,root,root)                /lib/security
%endif
  %attr(0555,root,root)		/%{_lib}/security/*.so
  %attr(0555,root,root)		/%{_lib}/security/pam_filter/*

  %attr(0511,root,root)		%dir %{_sysconfdir}/security
  %attr(0500,root,root)		%dir %{_sysconfdir}/security/console.apps

  %attr(0600,root,root)		%config(noreplace) %{_sysconfdir}/security/access.conf
  %attr(0600,root,root)		%config(noreplace) %{_sysconfdir}/security/chroot.conf
  %attr(0600,root,root)		%config(noreplace) %{_sysconfdir}/security/console.handlers
  %attr(0600,root,root)		%config(noreplace) %{_sysconfdir}/security/console.perms
  %attr(0600,root,root)		%config(noreplace) %{_sysconfdir}/security/console.perms.d/*
  %attr(0600,root,root)		%config(noreplace) %{_sysconfdir}/security/group.conf
  %attr(0600,root,root)		%config(noreplace) %{_sysconfdir}/security/time.conf
  %attr(0600,root,root)		%config(noreplace) %{_sysconfdir}/security/opasswd

  %attr(0644,root,root)		%config(noreplace) %{_sysconfdir}/security/limits.conf
  %attr(0644,root,root)		%config(noreplace) %{_sysconfdir}/security/pam_env.conf

%package devel
Summary:	Files needed for developing PAM-aware applications and modules.
Group:		Development/Libraries
Requires:	pam = %{version}-%{release}

%description devel
PAM (Pluggable Authentication Modules) is a system security tool that
allows system administrators to set authentication policy without
having to recompile programs that handle authentication. This package
contains header files and static libraries used for building both
PAM-aware applications and modules for use with PAM.

%files devel
  %defattr(0444,root,root,0555)
  %doc %{_mandir}/man3/*

  %attr(0444,root,root)		%{_includedir}/security/*.h
  %attr(0444,root,root)		%{_libdir}/*.a
  %attr(0555,root,root)		%{_libdir}/*.so
  %attr(0555,root,root)		/%{_lib}/*.so

%prep
%setup -q -n Linux-PAM-%{version} -a 1 -a 2
%patch100 -p1
%patch101 -p1
%patch102 -p1
%patch103 -p1
%patch104 -p1
%patch105 -p1
%patch106 -p1
%patch107 -p1
%patch108 -p1
%patch109 -p1
%patch110 -p1
%patch111 -p1
%patch112 -p1
%patch113 -p1
%patch114 -p1
%patch115 -p1
%patch300 -p1

  # Rename README's
  for readme in modules/pam_*/README ; do
    cp -f ${readme} doc/txts/README.`dirname ${readme} | sed -e 's|^modules/||'`
  done

  autoconf

%build
  export CFLAGS="-fPIC $RPM_OPT_FLAGS"

  topdir=`pwd`/pwdb-instroot
  test -d ${topdir}         || mkdir ${topdir}
  test -d ${topdir}/include || mkdir ${topdir}/include
  test -d ${topdir}/%{_lib}     || mkdir ${topdir}/%{_lib}

  pushd pwdb-%{pwdb_version}
    make %{?_smp_mflags}
    make install INCLUDED=${topdir}/include/pwdb LIBDIR=${topdir}/%{_lib} LDCONFIG=:
    rm ${topdir}/%{_lib}/*.so*
  popd

  export CPPFLAGS=-I${topdir}/include
  export LIBNAME="%{_lib}"
  export LDFLAGS=-L${topdir}/%{_lib}

  cp engarde/install-sh .

  %configure --libdir=/%{_lib} \
	--enable-static-libpam \
	--enable-fakeroot=$RPM_BUILD_ROOT \
	--enable-isadir=../../%{_lib}/security
  make %{?_smp_mflags}

%install
  [ "$RPM_BUILD_ROOT" != "/" ] && rm -rf $RPM_BUILD_ROOT

  # Install the binaries, libraries, and modules.
  make install FAKEROOT=$RPM_BUILD_ROOT

  # Install default configuration files.
  install -d $RPM_BUILD_ROOT%{_sysconfdir}/pam.d
  install engarde/other.pamd $RPM_BUILD_ROOT/%{_sysconfdir}/pam.d/other
  install engarde/system-auth.pamd $RPM_BUILD_ROOT/%{_sysconfdir}/pam.d/system-auth
  install /dev/null $RPM_BUILD_ROOT/%{_sysconfdir}/security/opasswd

  # Forcibly strip binaries.
  strip $RPM_BUILD_ROOT%{_root_sbindir}/* ||:

  # Install man pages.
  install -d $RPM_BUILD_ROOT%{_mandir}/man{3,5,8}
  install doc/man/*.3 $RPM_BUILD_ROOT%{_mandir}/man3/
  install doc/man/*.8 $RPM_BUILD_ROOT%{_mandir}/man8/

  # Move static libraries and make new .so links -- this depends on the value
  # of _libdir not changing, and *not* being /usr/lib.
  install -d $RPM_BUILD_ROOT%{_libdir}
  for lib in libpam libpamc libpam_misc ; do
    ln -sf ../../%{_lib}/${lib}.so.%{version} $RPM_BUILD_ROOT%{_libdir}/${lib}.so
    ln -sf ${lib}.so.%{version} $RPM_BUILD_ROOT/%{_lib}/${lib}.so
    mv $RPM_BUILD_ROOT/%{_lib}/${lib}.a $RPM_BUILD_ROOT%{_libdir}/
  done

  #
  # Make sure every module subdirectory gave us a module.  Yes, this is hackish.
  #
  for dir in modules/pam_* ; do
    if [ -d ${dir} ] ; then
	if ! ls -1 $RPM_BUILD_ROOT/%{_lib}/security/`basename ${dir}`*.so ; then
		echo ERROR `basename ${dir}` did not build a module.
		exit 1
	fi
    fi
  done

  # Install the pwdb configuration file.
  install pwdb-%{pwdb_version}/conf/pwdb.conf $RPM_BUILD_ROOT%{_sysconfdir}/

  # XXX
%ifarch x86_64
  install -d $RPM_BUILD_ROOT/lib
  ln -s ../lib64/security $RPM_BUILD_ROOT/lib
%endif

  # Remove unpackaged files.
  rm -f  doc/txts/README.pam_radius
  rm -f  $RPM_BUILD_ROOT/%{_lib}/security/pam_radius.so
  rm -fr $RPM_BUILD_ROOT/usr/doc/Linux-PAM

%post   -p /sbin/ldconfig
%postun -p /sbin/ldconfig

%clean
  [ "$RPM_BUILD_ROOT" != "/" ] && rm -rf $RPM_BUILD_ROOT

%changelog
* Tue Sep 06 2005 Ryan W. Maple <ryan@guardiandigital.com>
- Version 0.78, Release 3
  - Package /lib/security as a symlink to /lib64/security on x86_64 systems.

* Tue Jul 26 2005 Ryan W. Maple <ryan@guardiandigital.com>
- Version 0.78, Release 2
  - Turns out we don't need glib after all so scrap it.

* Tue Jun 29 2005 Pete O'Hara <pete@guardiandigital.com>
- Version 0.78, Release 1
  - Initial build for EnGarde Secure Linux 3.0.
